/*
Turing Machine Simulator
Copyright (C) 2005-2011 Samuel BWPOW Kupka, http://bwpow.eu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __TS_HEAD
#define __TS_HEAD

#define VERSION "1.2"

#define MOVE_LEFT 2
#define MOVE_RIGHT 1
#define MOVE_DONT 0

#define OUTPUT_CONF 1
#define OUTPUT_STATE 2
#define OUTPUT_COUNT 4
#define OUTPUT_POS 8

struct INFO{
  char quiet;
  char tsfile[256],infile[256],outfile[256];
  long int maxsteps,maxmemory;
  char input,output,tle,spos;
  char cl,cr; // left and right constraint
  char nt; // if 0, disable contraint characters, if 1 enable them
  int memory;
  char zero,one;
  int steps,state,pos;
};

#define MAX_STAV 2048
#define MAX_INSTR 2048

#ifndef stricmp
  #define stricmp strcasecmp
#endif

struct INSTR{
  short s,p,m;
};

/* main.cpp */
bool operator<(const INSTR &a,const INSTR &b);

/* load.cpp */
int load_input(void);
int load_ts(void);

/* run.cpp */
int run(void);

/* save.cpp */
int save_output(void);
int save_tle_output(void);
void print_output(void);

#endif
